// This file is part of TTDXRecolor.
// Copyright (c) 2010, Uwe Domaratius

#include "COptionObjects.hpp"
#include <iostream>

void COptionObject::printErrorMessage(const UInt32 error) const
{
   if (error)
   {
      std::cout << "Error: ";
      switch (error)
      {
      case E_COLOR_NO_NAME_DEFINED:
         std::cout << "no name for color defined.";
         break;
      case E_COLOR_NAME_CONTAINS_WHITESPACES:
         std::cout << "color name must not contain whitespaces.";
         break;
      case E_COLOR_NAME_IN_USE:
         std::cout << "color name already in use.";
         break;
      case E_COLOR_NOTHING_DEFINED:
         std::cout << "no color values or indices specified.";
         break;
      case E_COLOR_INDEX_OUT_OF_RANGE:
         std::cout << "index value out of range.";
         break;
      case E_COLOR_INCORRECT_VALUE_COUNT:
         std::cout << "incorrect number of values for RGB definition.";
         break;
      case E_COLOR_VALUE_OUT_OF_RANGE:
         std::cout << "color value out of range.";
         break;
      case E_COLOR_NOT_IN_PALETTE:
         std::cout << "color not in palette.";
         break;
      case E_GENERIC_MULTIPLE:
         std::cout << "only one generic section is allowed.";
         break;
      case E_REPLACE_UNDEFINED:
         std::cout << "Both from and to values for replacement need to be given.";
         break;
      case E_REPLACE_SIZE_MISMATCH:
         std::cout << "number of replacement options does not fit!.";
         break;
      case E_MERGE_OPTION_UNDEFINED:
         std::cout << "replace option not found.";
         break;
      case E_MERGE_OPTION_NUMBER:
         std::cout << "at least two options have to be given to merge them.";
         break;
      case E_MERGE_INDICES:
         std::cout << "cannot merge options as they work on the same table indices.";
         break;
      case E_MERGE_PALETTE:
         std::cout << "cannot merge options because output palette differs.";
         break;
      case E_NO_ERROR:
      default:
         break;
      }
      std::cout << std::endl;
   }
}
