// This file is part of TTDXRecolor.
// Copyright (c) 2010, Uwe Domaratius

#ifndef GTYPES_HPP
#define GTYPES_HPP

#include <boost/cstdint.hpp>
#include <sstream>
#include <string>
#include <iomanip>
#include <climits>

/// define standard integer types for usage throughout the program
typedef boost::int8_t   Int8;
typedef boost::int16_t  Int16;
typedef boost::int32_t  Int32;
typedef boost::int64_t  Int64;
typedef boost::uint8_t  UInt8;
typedef boost::uint16_t UInt16;
typedef boost::uint32_t UInt32;
typedef boost::uint64_t UInt64;

/// these conversions should be somewhere else, as they are completely 
/// generic, but then I again they're fine here
namespace NConvert
{
   inline
   UInt32 string2Int(const std::string& s)
   {
      UInt32 number = 0;
      std::stringstream ss(s);
      if (s.find("0x") == 0)
      {
         ss >> std::hex >> number;
      }
      else
      {
         ss >> std::dec >> number;
      }
      if (!ss.eof())
      {
         number = INT_MAX;
      }
      return number;
   }

   inline
   std::string int2String(const UInt32 i)
   {
      std::string s;
      std::stringstream ss;
      ss << std::setfill('0') << std::setw(2) << std::hex << i;
      ss >> std::uppercase >> s;
      return s;
   }
}

#endif
