// TTDXRecolor - a program to create and apply recolor tables onto PCX
// files as they are used in Transport Tycoon Deluxe.
// Copyright (c) 2010, Uwe Domaratius
//
// This software is protected by copyright laws and international copyright 
// treaties, as well as other intellectual property laws and treaties. All 
// copyrights in and to the software are owned by the aforementioned 
// copyright holder.
//
// Permission to use, copy, modify and/or redistribute this software including 
// its documentation for non-commercial purposes, without fee and without a 
// signed licensing agreement, is hereby granted, provided that the above 
// copyright notice, this paragraph and the following four paragraphs appear 
// in all copies and distributions.
//
// IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR DIRECT, 
// INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES, LOSS OF USE, 
// DATA, OR PROFITS) ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS 
// DOCUMENTATION, EVEN IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE 
// POSSIBILITY OF SUCH DAMAGE.
//
// THE SOFTWARE AND ACCOMPANYING DOCUMENTATION, IF ANY, PROVIDED HEREUNDER IS 
// PROVIDED "AS IS". THE COPYRIGHT HOLDER HAS NO OBLIGATION TO PROVIDE 
// MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
//
// ALL COMMERCIAL USE OF THIS SOFTWARE IS STRICTLY PROHIBITED.
// 
// ALL REDISTRIBUTION OF THIS SOFTWARE TO OTHER PARTIES FOR COMMERCIAL USE IS 
// STRICTLY PROHIBITED.

#include <iostream>
#include "CRecolorApplication.hpp"

/// the main method, instantiate an application object and run it
//lint -esym(765,main) main is not static
//lint -esym(714,main) main is referenced
//lint -esym(957,main) no prototype as there is no header for this file
int main(int argc, char* argv[])
{
   std::cout << "TTDXRecolor v0.1, Copyright (c) 2010, Uwe Domaratius" << std::endl;
   // parse the given cmd line + config file
   COptions options(argc,argv);

   // if help option was given, the help message was already shown, there is
   // nothing left to be done for the actual application
   // if option is not valid, some exception was encountered while parsing;
   // the exception was put to stdout, so the user can change the cmd line
   if (!options.isHelpRequested() && options.isValid())
   {
      // cmd line options seem to be ok, so we can start the actual application
      CRecolorApplication application(options);
      return application.run();
   }
   return 0;
}
